% Main program to generate examples for recovery from weak data
clear all;
ctr=0.1;  % support of trial functions
cts=0.05;  % support of test functions

hpr=0.1; % fill distance of trial points
hps=0.05; % fill distance of test  points
hint=min(hpr,hps)/5; % steplength for equidistant integration

yps=-1-cts:hps:1+cts; % set Y_s of test points
ypr=-1-ctr:hpr:1+ctr; % set Y_r of trial points

nps=length(yps); % number of points in Y_s
npr=length(ypr); % number of points in Y_r

a=zeros(nps,npr); % full matrix for the problem
rhs=zeros(nps,1);  % right-hand side

for ips=1:nps   % calculate right-hand side weak data
    locpoints=yps(ips)-cts:hint:yps(ips)+cts; % integration points
    val=fct(locpoints).*testwend(yps(ips),locpoints,cts); % integration values
    rhs(ips)=sum(val).*hint-val(1,1).*hint./2-val(1,end).*hint./2;
    % this was the trapezoidal rule. 
end
figure(1)
plot(yps,fct(yps))
ylim([-1-cts 1+cts])
ylim([-0.2 1.2])

figure(2)
plot(yps,rhs)
for ips=1:nps   % now for the full matrix 
    for jpr=1:npr
        locpoints=yps(ips)-cts:hint:yps(ips)+cts; % integration points 
        val=trialgauss(ypr(jpr),locpoints,ctr).*testwend(yps(ips),locpoints,cts); % integration values
        a(ips,jpr)=sum(val).*hint-val(1,1).*hint./2-val(1,end).*hint./2;
        % this was the trapezoidal rule. 
    end    
end
sizea=size(a)
co=a\rhs;
resid=rhs-a*co;
maxabs=max(abs(resid(:)))

evalpts=-1-cts:hps/2:1+cts;
tridat=trialgauss(evalpts,ypr,ctr)*co;
figure(3)
plot(evalpts,tridat)
ylim([-1-cts 1+cts])
ylim([-0.2 1.2])
figure(4)
plot(evalpts,tridat-fct(evalpts)')
ylim([-1-cts 1+cts])

return
